﻿Imports FarPoint.Win.Spread

Public Class Form1
    Private spread As FpSpread

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles Me.Load
        spread = New FpSpread()
        spread.Sheets.Add(New SheetView())

        spread.DataSource = GetDataTable()

        spread.Dock = DockStyle.Top
        spread.Height = Me.Height - 80
        Controls.Add(spread)

        Dim buttonSave = New Button()
        buttonSave.Text = "Save"
        buttonSave.AutoSize = True
        buttonSave.Location = New Point(40, spread.Bottom + 5)
        Controls.Add(buttonSave)

        For col = 0 To spread.ActiveSheet.ColumnCount - 1
            spread.AsWorkbook().ActiveSheet.Columns(col).AutoFit()
            'spread.ActiveSheet.SetColumnWidth(col,
            '    spread.ActiveSheet.GetPreferredColumnWidth(col, PreferredSizeColumnOptions.IncludeAll))
        Next

        AddHandler buttonSave.Click, AddressOf ButtonSave_Click
    End Sub

    Private Sub ButtonSave_Click(sender As Object, e As EventArgs)
        spread.SaveExcel("..\..\Files\Report.xlsx", FarPoint.Excel.ExcelSaveFlags.SaveCustomColumnHeaders Or
                         FarPoint.Excel.ExcelSaveFlags.UseOOXMLFormat)
    End Sub

    Private Function GetDataTable() As DataTable
        Dim table = New DataTable()
        table.Columns.Add("First Column", GetType(Integer))
        table.Columns.Add("Second Column", GetType(Integer))
        table.Columns.Add("Third Column", GetType(Integer))
        table.Columns.Add("Fourth Column", GetType(Integer))

        Dim random = New Random()
        For i = 1 To 100
            table.Rows.Add(random.Next(20, 100), random.Next(20, 100), random.Next(20, 100), random.Next(20, 100))
        Next

        Return table
    End Function
End Class
